#Diferents rutines de transformacio
#Per programa assemblador EduP12

from string import *

# constants
nMaxRam = 2**11-1

#def dec2hex(n):
#        '''return the hexadecimal string representation of integer n'''
#        return '%X' % n
 
#def hex2dec(s):
#        '''return the integer value of a hexadecimal string s'''
#        return int(s, 16)

def dec2bin(x,mod):
    '''Converteix un nombre a binari: torna un string
    x es el nombre a convertir
    mod es el modul
    exemple: toBin(11,16) --> 1011'''
    s=''
    x=x%mod+mod
    while x>1:
        if x%2: s = '1'+s
 	else: s = '0'+s
 	x //= 2
    return s

def unioLlista(l):
    s= ''
    for j in range(len(l)):
        s = s+l[j]+' '
    return s

def bin2dec(s):
    dec=0
    pot=1
    lon=len(s)
    for i in range(lon):
        dec=dec+pot*eval(s[lon-1-i])
        pot=pot*2
    return(dec)

#Mira si es numero decimal o hexadecimal, en nombre o string
#Retorna el numero en decimal o 'c' si no ho es
def siNum(d):
    s = str(d)
    if '-' in s:
        signe = -1
        s = s[1:]
    else:
        signe = 1
    if '0x' in s:
	for i in s[2:]:
            if i not in hexdigits: return 'nn'
	return (signe*eval(s))
    elif s.isdigit(): return (signe*eval(s))
    else: return 'nn'

#Mira si es registre (rxx) i el retorna en numero hexadecimal
def siReg(cad):
    if cad=='z': return 31
    elif cad=='y': return 30
    elif cad=='x': return 29
    elif len(cad)>0 and cad[0]=='r' and cad not in regsClone:
        if cad[1:].isdigit():
            n=eval(cad[1:])
            if n<0 or n>31: return 'nn'
            else: return n
        else: return 'nn'
    else: return 'nn'
    
   
#Diccionaris
regsClone = {'x': '00100', 'y': '01000', 'z': '10000',
             '+x': '00101', '+y': '01001', '+z': '10001',
             '-x': '00111', '-y': '01011', '-z': '10011'}

tipInstr =  {'nop':0, 'ret':0, 'reti':0, 'sei':0, 'cli':0, 'save':0, 'restore':0,
             'mov':1, 'add':1, 'adc':1, 'sub':1, 'sbc':1, 'cp':1, 'cpc':1, 'and':1, 'or':1, 'eor':1, 'tst':1,
             'ldi':2, 'addi':2, 'adci':2, 'subi':2, 'andi':2, 'ori':2, 'sbci':2, 'cpi':2, 'tsti':2, 'lds':2,
             'sts':22,
             'inc':3, 'dec':3, 'com':3, 'neg':3, 'asr':3, 'lsr':3, 'ror':3, 'rol':3, 'swap':3, 'pop':3, 'push':3,
             'rjmp':4, 'rcall':4,
             'ijmp':5, 'icall':5,
             'in':6, 'out':6,
             'brcc':7, 'brsh':7, 'brnz':7, 'brne':7, 'brpl':7, 'brvc':7,
             'brid':7,'brcs':7, 'brlo':7, 'brze':7, 'breq':7, 'brmi':7, 'brvs':7, 'brie':7,
             'brbs':77, 'brbc':77,
             'lpm':8, 'ld':8,
             'ldd':9,
             'st':10,
             'std':11,
             'bset':12, 'bclr':12,
             'lsl':13, 'clr':13}        #lsl->add, clr->eor

instruccio = {
        'nop':  '0000000000000000',
        'bset': '0000000100000...',
        'sei':  '0000000100000111',
        'bclr': '0000000100001...',
        'cli':  '0000000100001111',
        'mov':  '000001..........',
        'add':  '000010..........',
        'lsl':  '000010..........',    #add
        'adc':  '000011..........',
        'sub':  '000100..........',
        'sbc':  '000101..........',
        'cp':   '000110..........',
        'cpc':  '000111..........',
        'and':  '001000..........',
        'or':   '001001..........',
        'eor':  '001010..........',
        'clr':  '001010..........',    #eor
        'tst':  '001011..........',
        'ldi':  '0011000.....0000',
        'addi': '0011000.....0001',
	'andi': '0011000.....0010',
	'ori':  '0011000.....0011',
	'subi': '0011000.....0100',
	'sbci': '0011000.....0101',
	'cpi':  '0011000.....0110',
	'tsti': '0011000.....0111',
	'inc':  '0011000.....1000',
	'dec':  '0011000.....1001',
	'com':  '0011000.....1010',
	'neg':  '0011000.....1011',
	'asr':  '0011000.....1100',
	'lsr':  '0011000.....1101',
	'ror':  '0011000.....1110',
	'rol':  '0011000.....1111',
	'swap': '0011001.....0000',
	'rjmp': '0100............',
	'rcall':'0101............',
	'ijmp': '0110...000000010',
	'icall':'0110...000000011',
	'ret':  '0110000000000100',
	'reti': '0110000000000101',
	'pop':  '0110000.....0110',
	'push': '0110000.....0111',
	'restore':'0110100000000110',
	'save': '0110100000000111',
	'in':   '01110...........',
	'out':  '01111...........',
	'brbs': '1110............',
	'brcs': '1110............',
	'brlo': '1110.........000',
	'brze': '1110.........001',
	'breq': '1110.........001',
	'brmi': '1110.........010',
	'brvs': '1110.........011',
	'brie': '1110.........111',
	'brbc': '1111.........000',
	'brcc': '1111.........000',
	'brsh': '1111.........000',
	'brnz': '1111.........001',
	'brne': '1111.........001',
	'brpl': '1111.........010',
	'brvc': '1111.........011',
	'brid': '1111.........111',
	'lpm':  '1100........11..',
	'lds':  '1100000.....0100',
	'sts':  '1101000.....0100',
	'ld':   '1100........00..',
	'st':   '1101........00..',
	'ldd':  '10.0............',
	'std':  '10.1............'
        }

ports = {
        'porta':        '000000',   #entrada
        'portb':        '000001',   #sortida
        'porte':        '000010',
        'ext0ctrl':     '000011',
        'ss0':          '000100',
        'ss1':          '000101',
        'ss2':          '000110',
        'ss3':          '000111',
        'portcin':      '001000',
        'portcout':     '001001',
        'portcddr':     '001010',
        'timer0':       '010000',
        'timer0ctrl':   '010001',
        'timer0cmpa':   '010010',
        'timer0cmpb':   '010011',
        'servo0':       '010100',
        'servo0ctrl':   '010101',
        'servo0cmpa':   '010110',
        'servo0cmpb':   '010111',
        'pwm0ctrl':     '011000',
        'pwm0a':   	'011001',
        'uart0ctrl':    '100000',
        'uart0rxd':     '100001',
        'uart0txd':     '100010',
        'ftoc0ctrl':    '110000',
        'ftoc0':        '110001',
        'ftoc1ctrl':    '110010',
        'ftoc1':        '110011',
        'ftoc2ctrl':    '110100',
        'ftoc2':        '110101',
        'ftoc3ctrl':    '110110',
        'ftoc3':        '110111',
        }
	
capsal = ['library ieee;\n',
          'use ieee.std_logic_1164.all;\n',
          'use work.PK_eduP12.all;\n',
          'package NOM_PROGRAMA is\n',
          '     type mostra is record\n',
          '          dir: integer range 0 to 2**mp-1;\n',
          '          valor: std_logic_vector(15 downto 0);\n',
          '     end record;\n',
          '     type contingut_mem is array (natural range <>) of mostra;\n',
          '     constant test: contingut_mem:=(\n',
          '--initial adresses are for interrupts\n',
          '--adress 0 --> jump to main program\n',
          '---------------------------------------------------------------\n'
          ]

final = ['---------------------------------------------------------------\n',
          '( 2047, "0000000000000000")   -- nop\n',
          ');\n',
          'end;\n'
          ]
