-- COMUNICACIONS

.CON iniSS = 1599;	--Constants/definicions

.ORG 0;			--Inici programa
	RJMP main;
.ORG 14;			--Inici programa
	RJMP isrTxD;
.ORG 15;			--Inici programa
	RJMP isrRxD;

.ORG 32;		--Programa principal
main:	LDI X, iniSS;
	LPM R16, +X;
	OUT SS3, R16;
	LPM R16, +X;
	OUT SS2, R16;
	LPM R16, +X;
	OUT SS1, R16;
	LPM R16, +X;
	OUT SS0, R16;
	LDI R16, 0x30C;
	OUT UART0CTRL, R16;
	SEI;
torni:	RCALL leds;
	RCALL espera200;
	RJMP torni;
	NOP;

.ORG 60;
leds: 	IN R0, PORTA;
	OUT UART0TXD, R0;
	RET;
	NOP;
	
.ORG 100;		--Espera 200 ms
espera200: LDI R17, 0xc3;
bucle2:	LDI R16, 0xfff;
bucle1:	DEC R16;
	BRNZ bucle1;
	DEC R17;
	BRNZ bucle2;
	RET;
	NOP;
	NOP;

.ORG 1700;
isrTxD:	RETI;
	NOP;

.ORG 1750;
isrRxD:	IN R1, UART0RXD;
	OUT PORTB, R1;
	RETI;
	NOP;

	
.ORG 1600;		--Codis ascii2ss
hex2ss0: .dw 0x3F;
hex2ss1: .dw 0x6;
hex2ss2: .dw 0x5B;
hex2ss3: .dw 0x4F;
hex2ss4: .dw 0x66;
hex2ss5: .dw 0x6D;
hex2ss6: .dw 0x7D;
hex2ss7: .dw 0x7;
hex2ss8: .dw 0x7F;
hex2ss9: .dw 0x67;
hex2ss10: .dw 0x5F;
hex2ss11: .dw 0x7C;
hex2ss12: .dw 0x58;
hex2ss13: .dw 0x5E;
hex2ss14: .dw 0x79;
hex2ss15: .dw 0x71;
hex2ss16: .dw 0x80;
