
-- PROGRAMA COMUNICACI AMB PC
--	TxD sense interrupci, RxD amb interrupci
-- Adreces inicials: interrupcions
.org 0;
	RJMP main;	     	->a main
	nop;
	RJMP main;	     	->a main
	RJMP isrExt1dw ;	->a 640
	nop;
	nop;
	nop;
	nop;
	nop;
	nop;
	nop;
	nop;
	nop;
	nop;
	RJMP main;	     	->a main
	RJMP isrRxD ;		->a 1408
	RJMP error ;

--Programa principal
.org 32;
main:	RCALL iniciSS;
	LDI R16, 4;
	OUT ext0ctrl, R16;	--Activaci interrupci externa 1 down
	LDI R16,0x010C;		--Control usart: interrupci RxD, presc=12 (115200bauds-24MHz)
	OUT uart0ctrl, R16;
	SEI ;			--Activaci interrupts
retorn: RJMP retorn;
	NOP;

iniciSS:LDI X, hex2ss0;
	LPM R16, X;
	OUT SS0, R16;
	OUT SS1, R16;
	OUT SS2, R16;
	OUT SS3, R16;
	RET;
	NOP;
--Rutina d'interrupci Ext0-1-down
.org 640;
isrExt1dw: IN X, PORTA	;		--Agafar slides
	OUT uart0txd, X	;		--Enviar a TxD
	RETI;
	NOP;

--Rutina d'interrupci de recepci
.org 1408;
isrRxD: IN X, uart0rxd;		--rebre
	OUT PORTB, X;		--enviar a leds
	RETI;
	NOP;
	
--Rutina d'interrupci d'error
.org 1472;
error: LDI X, hex2ss16;
	LPM R16, X;
	OUT SS3, R16;
	RETI;
	NOP;

.org 1600;
hex2ss0: .dw 0x3F;
hex2ss1: .dw 0x6;
hex2ss2: .dw 0x5B;
hex2ss3: .dw 0x4F;
hex2ss4: .dw 0x66;
hex2ss5: .dw 0x6D;
hex2ss6: .dw 0x7D;
hex2ss7: .dw 0x7;
hex2ss8: .dw 0x7F;
hex2ss9: .dw 0x67;
hex2ss10: .dw 0x5F;
hex2ss11: .dw 0x7C;
hex2ss12: .dw 0x58;
hex2ss13: .dw 0x5E;
hex2ss14: .dw 0x79;
hex2ss15: .dw 0x71;
hex2ss16: .dw 0x80;
