-- PROGRAMA DE TEST DE SERVOs
--	Inicialitzat amb sortidaA a 150ms i sortidaB a 20us
--	Accions
--		+ augmenta A en 10us
--		- disminueix A en 10us
--		a aturat
--		e esquerra
--		d dreta
--		i inicialitzar (interruptors)

.CON a = 150;			->Aturat
.CON d = 200;			->Dreta
.CON e = 100;			->Esquerra

.DEF tmp = R16;
.DEF cmpa = R20;
.DEF caracter = R21;

.org 0;
	RJMP main;
.org 15;
	RJMP isrRxD ;
	
.org 32;
main:	LDI cmpa, a;
	OUT SERVO0cmpA, cmpa;	--Inicialitzat a 150
	LDI tmp, 2;
	OUT SERVO0cmpB, tmp;	--Pols de sincronisme
	LDI tmp, 0x7D0;
	OUT SERVO0, tmp;	--Comptador a 2000 (per anar a 20ms)
	LDI tmp, 0x6F0;
	OUT SERVO0ctrl, tmp;	--Habilitaci, prescaler a 240 (): 0b011011101111
	LDI tmp, 0x10C;		--Control usart: interrupci RxD, presc=12 (115200bauds-24MHz)
	OUT uart0ctrl, tmp;
	SEI;			--Activaci interrupts
	LDI caracter, a;
retorn: CPI caracter, 0;
	BRZE retorn;
	RCALL tractarCaracter;
	LDI caracter, 0;
	RJMP retorn;
	NOP;
		
.ORG 100;
tractarCaracter: CPI caracter, 0x2B;	--'+'
	BREQ esMes;
	CPI caracter, 0x2D;	--'-'
	BREQ esMenys;
	CPI caracter, 0x61;	--'a'
	BREQ esA;
	CPI caracter, 0x64;	--'d'
	BREQ esD;
	CPI caracter, 0x65;	--'e'
	BREQ esE;
	CPI caracter, 0x69;	--'i'
	BREQ esI;
	RET;
esMes:	INC cmpa;
	RJMP fi;
esMenys: DEC cmpa;
	RJMP fi;
esA:	LDI cmpa, a;
	RJMP fi;
esE:	LDI cmpa, e;
	RJMP fi;
esD:	LDI cmpa, d;
	RJMP fi;
esI:	IN cmpa, PORTA;
fi:	OUT SERVO0cmpA,cmpa;
	OUT PORTB, cmpa;		--enviar a leds
	RET;

--Rutina d'interrupci de recepci
.org 200;
isrRxD: IN caracter, uart0rxd;		--rebre
	RETI;
	NOP;