-- PROGRAMA DESPLAAMENT SET-SEGMENT

--Constants/definicions
.CON c7segm = 1600;

.DEF led = R30;
.DEF tmp = R29;

.ORG 0;			--Inici programa
	RJMP main;

.ORG 32;		--Programa principal
main:	LDI z, asciiRes;
altre:	LPM led, +z;
	OUT PORTB, led;
	RCALL petitaEspera;
	CPI z, ascii9;
	BRLO altre;
	IN led, PORTA;
	OUT PORTB, led;
	RCALL petitaEspera;
	RJMP main;

.ORG 100;		--Bucle d'espera
petitaEspera: LDI tmp, 4;
bucle:	DEC tmp;
	BRNZ bucle;
	RET;
	NOP;
	
.ORG c7segm;		--Conversio a 7-segment
asciiRes: .dw 0x00;
ascii0: .dw 0x30;
ascii1: .dw 0x31;
ascii2: .dw 0x32;
ascii3: .dw 0x33;
ascii4: .dw 0x34;
ascii5: .dw 0x35;
ascii6: .dw 0x36;
ascii7: .dw 0x37;
ascii8: .dw 0x38;
ascii9: .dw 0x39;
asciif: .dw 0x39;
asciiF: .dw 0x69;

