-- PROGRAMA DESPLAAMENT SET-SEGMENT

.CON iniSS = 1599;	--Constants/defincions
.DEF zero = R0;
.DEF u = R1;
.DEF led = R2;

.ORG 0;			--Inici programa
	RJMP main;

.ORG 32;		--Programa principal
main:	LDI X, iniSS;
	LPM zero, +X;
	LPM u, +X;
	LDI R16, 0x10C;
	OUT UART0CTRL, R16;
	SEI;
torni:	RCALL ss;
	RCALL leds;
	RJMP torni;

.ORG 50;
leds: 	IN led, PORTA;
	OUT PORTB, led;
	OUT UART0TXD, led;
	RET;
	NOP;

.ORG 60;
ss: 	OUT SS3, zero;
	OUT SS0, u;
	RCALL ESPERA200;
	OUT SS0, zero;
	OUT SS1, u;
	RCALL ESPERA200;
	OUT SS1, zero;
	OUT SS2, u;
	RCALL ESPERA200;
	OUT SS2, zero;
	OUT SS3, u;
	RCALL ESPERA200;
	RET;
	NOP;

.ORG 100;		--Espera 200 ms
espera200: LDI R17, 0xc3;
bucle2:	LDI R16, 0xfff;
bucle1:	DEC R16;
	BRNZ bucle1;
	DEC R17;
	BRNZ bucle2;
	RET;
	NOP;
	NOP;
	
.ORG 1600;		--Codis ascii2ss
hex2ss0: .dw 0x3F;
hex2ss1: .dw 0x6;
hex2ss2: .dw 0x5B;
hex2ss3: .dw 0x4F;
hex2ss4: .dw 0x66;
hex2ss5: .dw 0x6D;
hex2ss6: .dw 0x7D;
hex2ss7: .dw 0x7;
hex2ss8: .dw 0x7F;
hex2ss9: .dw 0x67;
hex2ss10: .dw 0x5F;
hex2ss11: .dw 0x7C;
hex2ss12: .dw 0x58;
hex2ss13: .dw 0x5E;
hex2ss14: .dw 0x79;
hex2ss15: .dw 0x71;
hex2ss16: .dw 0x80;

