-- PROVA DE TOTS INT'S AMB TIMERs

.DEF	ROVF = R0;
.DEF	RCMPA = R1;
.DEF	RCMPB = R2;
.DEF	TMP = R16;
.DEF	TMP2 = R17;

.ORG 0;				--Inici programa
	RJMP main;		--0
	RJMP isrExt0dw;		--1
	RJMP isrExt0up;		--2
	RJMP isrExt1dw;		--3
	RJMP isrExt1up;		--4
	RJMP isrExt2dw;		--5
	RJMP isrExt2up;		--6
	RJMP isrExt3dw;		--7
	RJMP isrExt3up;		--8
	RJMP isrTim0Ovf;	--9
	RJMP isrTim0CmpA;	--10
	RJMP isrTim0CmpB;	--11
	RJMP isrFtoc1;		--12
	RJMP isrFtoc0;		--13
	RJMP isrTxD;		--14
	RJMP isrRxD;		--15

.ORG 32;		--Programa principal
main:	LDI X, hex2ssPD;
	LPM TMP2, X;
	OUT SS3, TMP2;
	OUT SS2, TMP2;
	OUT SS1, TMP2;
	OUT SS0, TMP2;
	LDI TMP2, 0x30C;
	OUT UART0CTRL, TMP2;
	LDI TMP2, 0xFC;		--Ext1dw
	OUT EXT0CTRL, TMP2;
	LDI TMP2, 0x1EC;		--Control timer0: interrupts + presc a 2^12: 000 111 10 1100
	OUT TIMER0CTRL, TMP2;
	LDI TMP2, 0xAAA;		--ComparadorA timer0: a 2/3
	OUT TIMER0CMPA, TMP2;
	LDI TMP2, 0x555;		--ComparadorB timer0: a 1/3
	OUT TIMER0CMPB, TMP2;
	LDI ROVF, 0;
	LDI RCMPA, 0;
	LDI RCMPB, 0;
	SEI;
torni:	NOP;
	RJMP torni;
	NOP;

.ORG 1000;
isrExt0dw: LDI X, hex2ss1;
	LPM TMP, X;
	OUT SS3, TMP;
	RETI;
	NOP;

.ORG 1025;
isrExt0up: LDI X, hex2ss2;
	LPM TMP, X;
	OUT SS3, TMP;
	RETI;
	NOP;

.ORG 1050;
isrExt1dw: LDI X, hex2ss3;
	LPM TMP, X;
	OUT SS3, TMP;
	IN TMP, PORTA;
	OUT UART0TXD, TMP;
	RETI;
	NOP;

.ORG 1075;
isrExt1up: LDI X, hex2ss4;
	LPM TMP, X;
	OUT SS3, TMP;
	RETI;
	NOP;

.ORG 1100;
isrExt2dw: LDI X, hex2ss5;
	LPM TMP, X;
	OUT SS3, TMP;
	RETI;
	NOP;

.ORG 1125;
isrExt2up: LDI X, hex2ss6;
	LPM TMP, X;
	OUT SS3, TMP;
	RETI;
	NOP;

.ORG 1150;
isrExt3dw: LDI X, hex2ss7;
	LPM TMP, X;
	OUT SS3, TMP;
	RETI;
	NOP;

.ORG 1175;
isrExt3up: LDI X, hex2ss8;
	LPM TMP, X;
	OUT SS3, TMP;
	RETI;
	NOP;

.ORG 1200;
isrTim0Ovf: SAVE;
	MOV X, ROVF;
	ADDI X, hex2ss0;
	LPM TMP, X;
	OUT SS0, TMP;
	MOV TMP, ROVF;
	ADDI TMP, 0x30;
	OUT UART0TXD, TMP;
	CPI ROVF, 0;
	BRNZ fiOvf0;
	LDI ROVF, 16;
fiOvf0:	DEC ROVF;
	RESTORE;
	RETI;
	NOP;

.ORG 1225;
isrTim0CmpA: SAVE;
	MOV X, RCMPA;
	ADDI X, hex2ss0;
	LPM TMP, X;
	OUT SS1, TMP;
	CPI RCMPA, 0;
	BRNZ fiCmpA;
	LDI RCMPA, 16;
fiCmpA:	DEC RCMPA;
	RESTORE;
	RETI;
	NOP;

.ORG 1250;
isrTim0CmpB: SAVE;
	MOV X, RCMPB;
	ADDI X, hex2ss0;
	LPM TMP, X;
	OUT SS2, TMP;
	CPI RCMPB, 0;
	BRNZ fiCmpB;
	LDI RCMPB, 16;
fiCmpB:	DEC RCMPB;
	RESTORE;
	RETI;
	NOP;

.ORG 1275;
isrFtoc1: LDI X, hex2ssC;
	LPM TMP, X;
	OUT SS3, TMP;
	RETI;
	NOP;

.ORG 1300;
isrFtoc0: LDI X, hex2ssD;
	LPM TMP, X;
	OUT SS3, TMP;
	RETI;
	NOP;

.ORG 1325;
isrTxD:	LDI X, hex2ssE;
	LPM TMP, X;
	OUT SS3, TMP;
	RETI;
	NOP;

.ORG 1350;
isrRxD:	LDI X, hex2ssF;
	LPM TMP, X;
	OUT SS3, TMP;
	IN TMP, UART0RXD;
	OUT PORTB, TMP;
	RETI;
	NOP;

.ORG 1600;		--Codis ascii2ss
hex2ss0: .dw 0x3F;
hex2ss1: .dw 0x6;
hex2ss2: .dw 0x5B;
hex2ss3: .dw 0x4F;
hex2ss4: .dw 0x66;
hex2ss5: .dw 0x6D;
hex2ss6: .dw 0x7D;
hex2ss7: .dw 0x7;
hex2ss8: .dw 0x7F;
hex2ss9: .dw 0x67;
hex2ssA: .dw 0x5F;
hex2ssB: .dw 0x7C;
hex2ssC: .dw 0x58;
hex2ssD: .dw 0x5E;
hex2ssE: .dw 0x79;
hex2ssF: .dw 0x71;
hex2ssPD: .dw 0x80;
hex2ssU: .dw 0x3E;
